Class {
	#name : #'CMSpecPovSetter_Arc',
	#superclass : #CMSpecPovSetter,
	#instVars : [
		'startAnnotation',
		'widthChoices',
		'stopAnnotation',
		'lineWidth',
		'stopPosition',
		'startPosition'
	],
	#category : #'Cormas-UI-Spec1-PoV'
}

{ #category : #'initialize-release' }
CMSpecPovSetter_Arc >> initialize [
	
	super initialize.
	self lineWidth onChangeSend: #setLineWidth to: self.
	self startAnnotation onChangeSend: #setStartAnnotation to: self.
	self stopAnnotation onChangeSend: #setStopAnnotation to: self.
	self startPosition onChangeSend: #startPositionChanged to: self.
	self stopPosition onChangeSend: #stopPositionChanged to: self
]

{ #category : #aspects }
CMSpecPovSetter_Arc >> lineWidth [
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^lineWidth isNil
		ifTrue: [lineWidth := 1 asValue]
		ifFalse: [lineWidth]
]

{ #category : #'saving&removing pov symbols' }
CMSpecPovSetter_Arc >> removeClassMethodForSymbol: aSymbol [
	
	selectedClass class removeSelector: ('ArcPOV_' , aSymbol) asSymbol
]

{ #category : #'saving&removing pov symbols' }
CMSpecPovSetter_Arc >> saveArcPOV: aPOV intoClass: aClass symbol: aSymbol [
	
	| selector |
	selector := 'ArcPOV_' , aSymbol.
	aClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of a Arc entity pov symbol in the following order:\(lineColor red) (lineColor green) (lineColor blue) lineWidth startAnnotation stopAnnotation startPosition stopPosition"\^#('
				, aPOV lineColor red printString , ' '
				, aPOV lineColor green printString , ' '
				, aPOV lineColor blue printString , ' ' , aPOV lineWidth printString ,
					' ' , aPOV startAnnotation printString , ' '
				, aPOV stopAnnotation printString , aPOV startPosition printString ,
					' ' , aPOV stopPosition printString , ' ' , ')') withCRs
		classified: 'pov symbols'
		notifying: nil
]

{ #category : #aspects }
CMSpecPovSetter_Arc >> startAnnotation [
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^startAnnotation isNil
		ifTrue: [startAnnotation := false asValue]
		ifFalse: [startAnnotation]
]

{ #category : #aspects }
CMSpecPovSetter_Arc >> startPosition [
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^startPosition isNil
		ifTrue: [startPosition := #center asValue]
		ifFalse: [startPosition]
]

{ #category : #aspects }
CMSpecPovSetter_Arc >> stopAnnotation [
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^stopAnnotation isNil
		ifTrue: [stopAnnotation := true asValue]
		ifFalse: [stopAnnotation]
]

{ #category : #aspects }
CMSpecPovSetter_Arc >> stopPosition [
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^stopPosition isNil
		ifTrue: [stopPosition := #center asValue]
		ifFalse: [stopPosition]
]
